from qt import * 

from TreeGraph import *

class ScrollViewTreeGraph(QScrollView):
    def __init__(self, document=None, *args):
        apply(QScrollView.__init__,(self,) + args)
        self.viewport().setEraseColor(QColor(255,255,255))
        self.treeGraph = TreeGraph(document, self)
        self.addChild(self.treeGraph)
    def setNewTree(self, tree):
        self.treeGraph.setNewTree(tree)
    def updateRobot(self, robot):
        self.treeGraph.updateRobot(robot)

sample1 = If(And(One(), N()), Or(South(), E()), One())
sample2 = And(Or(N(), East()), South())
tree = Zero()
tree2 = North()
tree3 = N()
tree4 = Not(N())
tree5 = If(And(N(),S()), And(E(),W()), And(North(), South()))
tree6 = And(N(),And(S(),And(South(),North())))    ## there is a bug
tree7 = And(N(),And(South(),North()))    ## there is a bug
tree8 = And(N(),And(And(N(),East()),And(South(),North())))    ## there is a bug
tree9 = And(And(North(),N()),And(N(),And(South(),North())))    ## there is a bug
tree10 = And(N(),If(South(),E(),North()))    ## there is a bug
tree11 = And(N(),And(S(),If(South(),S(),North())))    ## there is a bug
tree12 = If(And(N(), South()),Not(And(East(), And(West(), E()))),South())

generated1 = If(W(), And(If(Or(South(), If(West(), W(), And(North(), North()))), East(), North()), And(South(), SW())), If(W(), And(If(Or(South(), If(Or(South(), Zero()), South(), And(North(), North()))), East(), North()), And(South(), Or(If(If(Not(W()), If(If(Not(W()), West(), North()), North(), If(NE(), West(), North())), North()), West(), North()), East()))), Not(If(N(), West(), North()))))
generated2 = And(And(If(SW(), If(Or(South(), If(South(), And(And(If(And(South(), South()), NW(), NE()), SW()), SW()), If(South(), East(), West()))), NW(), NE()), West()), NE()), North())
generated3 = If(Not(NE), If(South, If(West, E, South), SE), North)
generated4 = If(Or(NW(),North()),If(If(NE(),Or(East(),If(NW(),East(),North())),North()),If(If(NW(),Or(East(),North()),North()),North(),South()),South()),NE())

if __name__ == "__main__":
    import sys
    app=QApplication(sys.argv)
    scrollViewTreeGraph = ScrollViewTreeGraph()
    app.setMainWidget(scrollViewTreeGraph)
    scrollViewTreeGraph.setNewTree(generated4)
    robot = Robot(1,1)
    scrollViewTreeGraph.updateRobot(robot)
    scrollViewTreeGraph.show()
    app.exec_loop()
