from settings import *

SINGLE_CROSSOVER = 1
DOUBLE_CROSSOVER = 2

class SettingsDialog(settings):
    def __init__(self, parent = None, name = None, modal = 0, fl = 0):
        settings.__init__(self, parent, name, modal, fl)
        self.crossoverType = SINGLE_CROSSOVER
    
    def restoreSettings(self, crossover_type, population_size, generation_count, crossover_percentage):
        if (crossover_type == DOUBLE_CROSSOVER):
            self.singleCrossover.setChecked(False)
            self.doubleCrossover.setChecked(True)
        self.populationSize.setValue(population_size)
        self.numOfGenerations.setValue(generation_count)
        self.crossoverPercentage.setValue(crossover_percentage)
    
    def getCrossoverType(self):
        return self.crossoverType
    
    def getPopulationSize(self):
        return self.populationSize.value()
    
    def getGenerationCount(self):
        return self.numOfGenerations.value()
    
    def getCrossoverPercentage(self):
        return self.crossoverPercentage.value()
    
    def setSingleCrossover(self):
        self.crossoverType = SINGLE_CROSSOVER
    
    def setDoubleCrossover(self):
        self.crossoverType = DOUBLE_CROSSOVER
    
    def setPopulationSize(self):
        pass
    
    def setNumOfGenerations(self):
        pass
    
    def setCrossoverPercentage(self):
        pass
    
##~     def setCrossoverOption(self):
##~         print "settings.setCrossoverOption(): Not implemented yet"

if __name__ == "__main__":
    a = QApplication(sys.argv)
    QObject.connect(a,SIGNAL("lastWindowClosed()"),a,SLOT("quit()"))
    w = SettingsDialog()
    a.setMainWidget(w)
    w.show()
    w2 = SettingsDialog()
    w2.setModal(True)
    w2.exec_loop()
    print w2.getPopulationSize()
    a.exec_loop()
